<?php

/***************************************************************************
*                            Dolphin Smart Community Builder
*                              -------------------
*     begin                : Mon Mar 23 2006
*     copyright            : (C) 2007 BoonEx Group
*     website              : http://www.boonex.com
* This file is part of Dolphin - Smart Community Builder
*
* Dolphin is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the
* License, or  any later version.
*
* Dolphin is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
* without even the implied warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with Dolphin,
* see license.txt file; if not, write to marketing@boonex.com
***************************************************************************/
define("ADMIN_ROLE","3");
define("LOGIN_SUCCESS",0);
define("LOGIN_PASSWD_ERROR",1);
define("LOGIN_NICK_EXIST",2);
define("LOGIN_ERROR",3);
define("LOGIN_ERROR_NOUSERID",4);
define("LOGIN_SUCCESS_ADMIN",5);
define("LOGIN_NOT_ALLOW_GUEST",6);
define("LOGIN_USER_BANED",7);

bx_import('BxDolModule');

require_once(dirname(__FILE__).'/requestRemote.php');

class TmChatModule extends BxDolModule
{
    /**
	 * Class constructor ;
	 */
	function TmChatModule(&$aModule)
    {
        parent::BxDolModule($aModule);
    }

    /**
     * Function will generate the chat's page;
     */
    function actionHome()
    {
        $this->_oTemplate->pageStart();
        
        $chaturl = $this->getFlashChatUrl();
        
		if ($user = getProfileInfo()){
			if(!empty( $user['NickName'] )){
				$chaturl .= "&init_user=" . rawurlencode($user['NickName']) . "&init_password=" . rawurlencode($user['Password']);
			}
		}		
        
        $extendserver = getParam('fc_extendserver');
		$servertype = getParam('fc_servertype');
		$clienttype = getParam('fc_clienttype');
		$client_loc = getParam('fc_client_loc');
		$fullscreen = getParam('fc_fullscreen');
		
		$chattype = '';
		if($extendserver == 2){
			$chattype = 'free';
		}elseif ($extendserver == 1){
			if($clienttype == 1){
				$chattype = 'flash';
			}else{
				$chattype = 'html';
			}
		}else{
			if($servertype != 1 && $clienttype == 1){
				$chattype = 'flash';
			}else{
				$chattype = 'html';
			}
		}
		
		if($fullscreen == 1){
			$width = "100%";
			$height = "100%";
		}else{
			$width = getParam('fc_client_width');
            $height = getParam('fc_client_height');
		}
		
        $aVars = array (
        	'bx_if:fullscreenheader' => array(
                'condition' => ($fullscreen == 1) ? true : false,
                'content' => array(),
            ),
            'bx_if:fullscreenfooter' => array(
                'condition' => ($fullscreen == 1) ? true : false,
                'content' => array(),
            ),
            'bx_if:cusscreenheader' => array(
                'condition' => ($fullscreen != 1) ? true : false,
                'content' => array(),
            ),
            'bx_if:cusscreenfooter' => array(
                'condition' => ($fullscreen != 1) ? true : false,
                'content' => array(),
            ),
            'bx_if:default_chat' => array(
                'condition' => ($chattype == 'flash') ? true : false,
                'content' => array(),
            ),
            'bx_if:html_chat' => array(
                'condition' => ($chattype == 'html') ? true : false,
                'content' => array(),
            ),
            'bx_if:free_chat_full' => array(
                'condition' => ($chattype == 'free') ? true : false,
                'content' => array(),
            ),
            'bx_if:free_chat_cus' => array(
                'condition' => ($chattype == 'free') ? true : false,
                'content' => array(),
            ),
            'client_loc' => getParam('fc_client_loc'),
            'chaturl' => $chaturl,
            'width' => $width,
            'height' => $height,
        );
        echo $this->_oTemplate->parseHtmlByName('123flashchat', $aVars);
        if ($fullscreen != 1){
            $this->_oTemplate->pageCode(_t('_tm_chat'));
        }
    }

    /**
     * Function will generate the chat login return value;
     */
    function actionLogin(){
    	bx_import('BxBaseFunctions');
        $oBaseFunctions = new BxBaseFunctions();
        if (isset($_GET['username']) && isset($_GET['password'])){
            $sPassword = $_GET['password'];
            $iId = getID($_GET['username']);
            if (!$iId){
                echo LOGIN_ERROR_NOUSERID;
            }else{
                $aUser = getProfileInfo($iId);
				$url = "";
				$birth = str_replace("-","",$aUser['DateOfBirth']);
				if(!empty($birth) && $birth > 19010101){
					$url .= "|a=".$birth;
				}
				$url .= $url ? ( ($aUser['Sex'])? ("&s=".(($aUser['Sex']=="female")?2:1)) : "" ) : (($aUser['Sex'])? ("|s=".(($aUser['Sex']=="female")?2:1)) : "") ;
				$url .= $url ? (($aUser['Email'])? ("&eml=".$aUser['Email']) : "") : (($aUser['Email'])? ("|eml=".$aUser['Email']) : "");
				$url .= $url ? (($aUser['City'])? ("&l=".$aUser['City']) : "") : ($aUser['City']? ("|l=".$aUser['City']): "");
				$url .= $url ? (($aUser['Avatar'])? ("&avt=".$oBaseFunctions -> getMemberAvatar($iId,'small')."&lckavt=0") : "") : ($aUser['Avatar']? ("&avt=".$oBaseFunctions -> getMemberAvatar($iId,'small')."&lckavt=0"): "");
				
                if ( ($sPassword == $aUser['Password']) || ($aUser['Password'] == encryptUserPwd($sPassword, $aUser['Salt'])) ){
                    if ($aUser['Role'] == ADMIN_ROLE){
                        echo LOGIN_SUCCESS_ADMIN.$url;
                    }else{
                        echo LOGIN_SUCCESS.$url;
                    }
                }else{
                    echo LOGIN_PASSWD_ERROR;
                }
            }
        }else{
            echo LOGIN_ERROR;
        }
    }
/**
    /**
     * Function will generate the chat's settings;
     *
     * @return : (text) - Html presentation data ;
     */
/*
 *  settings no javascript
    function actionSettings()
    {
        if (!$GLOBALS['logged']['admin']) {
            $this->_oTemplate->displayAccessDenied ();
            return;
        }

        // try to define globals category number;
        $iId = $this-> _oDb -> getSettingsCategory('fc_server');
        if(!$iId) {
            $sContent = MsgBox( _t('_Empty') );
        }
        else {
            bx_import('BxDolAdminSettings');

            $mixedResult = '';
            if(isset($_POST['save']) && isset($_POST['cat'])) {
                $oSettings = new BxDolAdminSettings($iId);
                $mixedResult = $oSettings -> saveChanges($_POST);
            }

            $oSettings = new BxDolAdminSettings($iId);
            $sResult = $oSettings->getForm();

            if($mixedResult !== true && !empty($mixedResult))
                $sResult = $mixedResult . $sResult;

            $sCssStyles = $this -> _oTemplate -> addCss( 'forms_adv.css', true );

            $sContent = $sCssStyles . $GLOBALS['oAdmTemplate']
                    -> parseHtmlByName( 'design_box_content.html', array('content' => $sResult) );
        }

        $this -> _oTemplate-> pageStart();
        echo $this -> _oTemplate -> adminBlock ($sContent, _t('_tm_chat_settings'));
        $this -> _oTemplate->pageCodeAdmin ( _t('_tm_chat') );
    }
*/
    function actionSettings(){
        if (!$GLOBALS['logged']['admin']) {
            $this->_oTemplate->displayAccessDenied ();
            return;
        }
        if(isset($_POST['save']) && isset($_POST['cat'])){
            $mixedResult = "";
		    switch($_POST['extendserver']){
		    	case 0:
		    		$result = $this->saveLocalSettings();
		    		break;
		    	case 1:
		    		$result = $this->saveHostSettings();
		    		break;
		    	case 2:
		    	default:
		    		$result = $this->saveFreeSettings();
		    		break;
		    }
		    
		    if(!is_array($result)){
		    	$mixedResult = $result;
		    	$error_id = 'error_'.time();
		    	$mixedResult = '<div class="MsgBox" id="'.$error_id.'">
				    <table class="MsgBox bx-def-margin-top bx-def-margin-bottom"><tr><td>
				        <div class="msgbox_content bx-def-font-large bx-def-padding-sec" style="color:red;">'.$result.'</div>
				    </td></tr></table>
					<script type="text/javascript" language="javascript">
				            setTimeout("$(\'#'.$error_id.'\').bx_anim(\'hide\', \'fade\', \'slow\', function() { $(this).remove();  } )", 5000);
				    </script>
			    </div>';
		    }else{
		    	$data = $result;		    
	            $data['cat'] = $_POST['cat'];
			    $data['fc_room_list'] = $_POST['room_list'] ? $_POST['room_list'] : 0;
			    $data['fc_user_list'] = $_POST['user_list'] ? $_POST['user_list'] : 0;
			    $data['fc_fullscreen'] = ($_POST['fullscreen'] > 0) ? 1 : 0;
			    
	            $data['fc_client_width'] = ($_POST['client_width'] > 760 ) ? $_POST['client_width'] : 760;
	            $data['fc_client_height'] = ($_POST['client_height'] > 642 ) ? $_POST['client_height'] : 642;
		        $data['fc_client_lang'] = isset($_POST['client_lang']) ? $_POST['client_lang'] : "en";
	            $data['fc_client_skin'] = $_POST['client_skin'];
		    }
            if (!$mixedResult)
            {
                $iId = $this-> _oDb -> getSettingsCategory('fc_extendserver');
                bx_import('BxDolAdminSettings');
                $oSettings = new BxDolAdminSettings($iId);
                $mixedResult = $oSettings -> saveChanges($data);
            }
        }
        if (!isset($data))
        {
            $data['fc_extendserver'] = getParam('fc_extendserver');
            $data['fc_servertype'] = getParam('fc_servertype');
            $data['fc_server_host'] = getParam('fc_server_host');
            $data['fc_server_port'] = getParam('fc_server_port');
            $data['fc_server_host_s'] = getParam('fc_server_host_s');
            $data['fc_server_port_s'] = getParam('fc_server_port_s');
            $data['fc_server_host_h'] = getParam('fc_server_host_h');
            $data['fc_server_port_h'] = getParam('fc_server_port_h');
            $data['fc_client_loc'] = getParam('fc_client_loc');
            $data['fc_room'] = getParam('fc_room');
            $data['fc_fullscreen'] = getParam('fc_fullscreen');
            $data['fc_room_list'] = getParam('fc_room_list');
            $data['fc_user_list'] = getParam('fc_user_list');
            $data['fc_clienttype'] = getParam('fc_clienttype');
            $data['fc_client_width'] = getParam('fc_client_width');
            $data['fc_client_height'] = getParam('fc_client_height');
            $data['fc_client_lang'] = getParam('fc_client_lang');
            $data['fc_client_skin'] = getParam('fc_client_skin');
        }else{

            setParam('fc_extendserver',$data['fc_extendserver']);
            setParam('fc_servertype',$data['fc_servertype']);
            setParam('fc_server_host',$data['fc_server_host']);
            setParam('fc_server_port',$data['fc_server_port']);
            setParam('fc_server_host_s',$data['fc_server_host_s']);
            setParam('fc_server_port_s',$data['fc_server_port_s']);
            setParam('fc_server_host_h',$data['fc_server_host_h']);
            setParam('fc_server_port_h',$data['fc_server_port_h']);
            setParam('fc_client_loc',$data['fc_client_loc']);
            setParam('fc_room',$data['fc_room']);
            setParam('fc_fullscreen',$data['fc_fullscreen']);
            setParam('fc_room_list',$data['fc_room_list']);
            setParam('fc_user_list',$data['fc_user_list']);
            setParam('fc_clienttype',$data['fc_clienttype']);
            setParam('fc_client_width',$data['fc_client_width']);
            setParam('fc_client_height',$data['fc_client_height']);
            setParam('fc_client_lang',$data['fc_client_lang']);
            setParam('fc_client_skin',$data['fc_client_skin']);
            setParam('fc_api_url',$data['fc_api_url']);
            setParam('fc_group',$data['fc_group']);

		}
        $user = getProfileInfo();
        $valid = $this->getValid();
        $aVars = array (        	
        	'dis_free_hidden'			=> $data['fc_extendserver'] == "2" ? 'style="display:none;"' : "",
        	'dis_not_free_hidden'		=> $data['fc_extendserver'] == "2" ? "" : 'style="display:none;"',
        	'dis_not_own_hidden'		=> $data['fc_extendserver'] == "0" ? "" : 'style="display:none;"',
        	'dis_not_host_hidden'		=> $data['fc_extendserver'] == "1" ? "" : 'style="display:none;"',
        	'dis_servertype'			=> $data['fc_extendserver'] == "0" ? "" : 'style="display:none;"',
        	'dis_hostport'				=> (!$valid || $data['fc_servertype'] != "0") ? 'style="display:none;"' : "",
        	'dis_clienttype'			=> ($data['fc_extendserver'] == "2" || ($data['fc_extendserver'] == "0" && $data['fc_servertype'] == "1")) ? 'style="display:none;"' : "",
        	'dis_fullscreen_hidden'		=> $data['fc_fullscreen'] == "1" ? 'style="display:none;"' : "",
        
            'check_own' 				=> $data['fc_extendserver'] == "0" ? "checked" : "",
            'check_fc' 					=> $data['fc_extendserver'] == "1" ? "checked" : "",
            'check_free' 				=> $data['fc_extendserver'] == "2" ? "checked" : "",        
        	'check_servertype_flash'	=> $data['fc_servertype'] != "1" ? "checked" : "",
        	'check_servertype_ppv'		=> $data['fc_servertype'] == "1" ? "checked" : "",
        	'check_clienttype_html'		=> $data['fc_clienttype'] != "1" ? "checked" : "",
        	'check_clienttype_flash'	=> $data['fc_clienttype'] == "1" ? "checked" : "",
        	'check_user_list_yes'		=> $data['fc_user_list'] == "1" ? "checked" : "",
        	'check_user_list_no'		=> $data['fc_user_list'] != "1" ? "checked" : "",
        	'check_room_list_yes'		=> $data['fc_room_list'] == "1" ? "checked" : "",
        	'check_room_list_no'		=> $data['fc_room_list'] != "1" ? "checked" : "",
        	'check_fullscreen_yes'		=> $data['fc_fullscreen'] == "1" ? "checked" : "",
        	'check_fullscreen_no'		=> $data['fc_fullscreen'] != "1" ? "checked" : "",
        
        	'base_url'					=> BX_DOL_URL_ROOT,
        	'servername'				=> $_SERVER['SERVER_NAME'],
        
        	'server_host'				=> $data['fc_server_host'],
        	'server_port'				=> $data['fc_server_port'] ? $data['fc_server_port'] : "",
        	'http_port'					=> $data['fc_server_port_h'] ? $data['fc_server_port_h'] : "",
        	'client_loc'				=> $data['fc_client_loc'] ? $data['fc_client_loc'] : "",
        	'default_server_port'		=> $data['fc_servertype'] == "1" ? "51212" : "51127",
        	'default_server_port_h'		=> $data['fc_servertype'] == "1" ? "31212" : "35555",
        	'room'						=> $data['fc_room'],
        	'client_width' 				=> $data['fc_client_width'],
            'client_height' 			=> $data['fc_client_height'],
        
        	'sel_auto' => $data['fc_client_lang'] == "*" ? "selected" : "",
            'sel_en' => $data['fc_client_lang'] == "en" ? "selected" : "",
            'sel_zh-CN' => $data['fc_client_lang'] == "zh-CN" ? "selected" : "",
            'sel_zh-TW' => $data['fc_client_lang'] == "zh-TW" ? "selected" : "",
            'sel_fr' => $data['fc_client_lang'] == "fr" ? "selected" : "",
            'sel_it' => $data['fc_client_lang'] == "it" ? "selected" : "",
            'sel_de' => $data['fc_client_lang'] == "de" ? "selected" : "",
            'sel_nl' => $data['fc_client_lang'] == "nl" ? "selected" : "",
            'sel_hu' => $data['fc_client_lang'] == "hu" ? "selected" : "",
            'sel_es' => $data['fc_client_lang'] == "es" ? "selected" : "",
            'sel_hr' => $data['fc_client_lang'] == "hr" ? "selected" : "",
            'sel_tr' => $data['fc_client_lang'] == "tr" ? "selected" : "",
            'sel_ar' => $data['fc_client_lang'] == "ar" ? "selected" : "",
            'sel_pt' => $data['fc_client_lang'] == "pt" ? "selected" : "",
            'sel_ru' => $data['fc_client_lang'] == "ru" ? "selected" : "",
            'sel_ko' => $data['fc_client_lang'] == "ko" ? "selected" : "",
            'sel_serbian' => $data['fc_client_lang'] == "serbian" ? "selected" : "",
            'sel_no' => $data['fc_client_lang'] == "no" ? "selected" : "",
            'sel_ja' => $data['fc_client_lang'] == "ja" ? "selected" : "",
        
        	'sel_default' => $data['fc_client_skin'] == "default" ? "selected" : "",
            'sel_green' => $data['fc_client_skin'] == "green" ? "selected" : "",
            'sel_orange' => $data['fc_client_skin'] == "orange" ? "selected" : "",
            'sel_red' => $data['fc_client_skin'] == "red" ? "selected" : "",
            'sel_black' => $data['fc_client_skin'] == "black" ? "selected" : "",
            'sel_beige' => $data['fc_client_skin'] == "beige" ? "selected" : "",
            'sel_standard' => $data['fc_client_skin'] == "standard" ? "selected" : "",
            'sel_clean' => $data['fc_client_skin'] == "clean" ? "selected" : "",
            'sel_artistic' => $data['fc_client_skin'] == "artistic" ? "selected" : "",
        	'sel_lightblue' => $data['fc_client_skin'] == "lightblue" ? "selected" : "",
        );
        $sResult = $this->_oTemplate->parseHtmlByName('settings', $aVars);
        if($mixedResult !== true && !empty($mixedResult))
            $sResult = $mixedResult . $sResult;
        $sCssStyles = $this -> _oTemplate -> addCss( 'forms_adv.css', true );
        $sContent = $sCssStyles . $GLOBALS['oAdmTemplate']
                    -> parseHtmlByName( 'design_box_content.html', array('content' => $sResult) );
        $this -> _oTemplate-> pageStart();
        echo $this -> _oTemplate -> adminBlock ($sContent, _t('_tm_chat_settings'));
        $this -> _oTemplate->pageCodeAdmin ( _t('_tm_chat') );
    }
    /**
	* Check 123 FlashChat Server Config
	* @parm $host   Chat Server Host
	* @parm $port   Chat Server Port
	* @return integer config status
	*/
    function validate_server($host, $port)
    {   $s_own_loc = 1;
        $apiCommand = '<Init/>';
        $resultDoc = "";
        $fp = fsockopen($host, $port, $errno, $errstr, 2);
        if($fp)
        {
            fputs($fp,$apiCommand."\0");
            while (!feof($fp))
            {
                $resultDoc .= fgets($fp, 1024);
                $resultDoc = rtrim($resultDoc);
            }
            $parser = xml_parser_create("UTF-8");
            xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
            xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
            if (xml_parse_into_struct($parser, $resultDoc, $values, $tags))
            {
                if($values)
                {
                    $s_own_loc = 0;
                }
                xml_parser_free($parser);
                fclose($fp);
            }
        }
        return $s_own_loc;
    }

    /**
	* Check 123 FlashChat Data api
	* @parm $data_api   Chat Data Api
	* @return integer config status
	*/
    function validate_data_api($data_api){
    	$da = 1;
		if(substr(topcmmRequestRemote::requestRemote($data_api,0), 9, 3) == 200){
			$da = 0;
		}
		return $da;
    }

    /**
	* Check 123 FlashChat Client Location
	* @parm $client_loc   Chat Client Location
	* @return integer config status
	*/
    function validate_client($client_loc){
		$c_own_loc = 1;
		$swf = $client_loc . 'admin_123flashchat.swf';
        if($headers = topcmmRequestRemote::requestRemote($swf,0)){
            $c_own_loc = (substr($headers, 9, 3) == '200') ? 0 : 1;
        }
        return $c_own_loc;
    }
    /**
     * Function will generate the chat's settings;
     *
     * @return : (text) - Html presentation data ;
     */
    function actionAdminPanel(){
        if (!$GLOBALS['logged']['admin']) {
            $this->_oTemplate->displayAccessDenied ();
            return;
        }

        $this -> _oTemplate-> pageStart();
        $extendserver = getParam('fc_extendserver');
        $user = getProfileInfo();
        $aVars = array (
            'bx_if:default_chat_admin' => array(
                'condition' => ($extendserver != "2") ? true : false,
                'content' => array(),
            ),
            'bx_if:free_chat_admin' => array(
                'condition' => ($extendserver == "2") ? true : false,
                'content' => array(),
            ),
            'client_loc_admin' => getParam('fc_client_loc') . "123flashchat.js",
            'url' => getParam('fc_client_loc') . "admin_123flashchat.swf?init_host=" . getParam('fc_server_host') . "&init_port=" . getParam('fc_server_port') . "&init_user=" . rawurlencode($user['NickName']) . "&init_password=" . rawurlencode($user['Password']) . (($extendserver == "1") ? ("&init_group=" . getParam('fc_group')) : ""),
        );
        $sContent = $this->_oTemplate->parseHtmlByName('adminpanel', $aVars);
        echo $this -> _oTemplate -> adminBlock ($sContent, _t('_tm_chat_admin_panel'));
        $this -> _oTemplate->pageCodeAdmin ( _t('_tm_chat') );
    }

	function serviceGetWhosChatBubble() {
		$iNewNotifyCount = 0;
		$aNotifyMessages = array();		
		$status = self::getStatus();
		if(isset($status['ln']) && is_numeric($status['ln']) && $status['ln'] > 0){
			$iNewNotifyCount = $status['ln'];
		}
		$aRetEval = array('count' => $iNewNotifyCount,'messages'=>$aNotifyMessages);
		return $aRetEval;
	}
	
	function serviceGetWhosChat(){
		bx_import('BxBaseFunctions');
        $oBaseFunctions = new BxBaseFunctions();
		$users = self::getUsers();
		$sCode .= '<div id="WhosChat" style="padding-top: 7px; padding-bottom: 7px;">';
		if(is_array($users)){
			$guestnum = 0;
			foreach($users as $key => $value){
				$iId = getID($value['name']);
				if($iId){
					$aMemChat[] = getProfileInfo($iId);
				}else{
					$guestnum ++;
				}
				//$usernames[] = $value['name'];
			}
			if(isset($aMemChat) && is_array($aMemChat)){
				$sCode .= '<table border="0" cellspacing="0" cellpadding="0">';
				foreach ($aMemChat as $key => $aRow){
					$sCode .= '
						<tr>
							<td style="padding:3px 4px">
								<div class="pic_spacer">
								<div class="thumbnail_block thumbnail_block_icon">
									<div class="thumbnail_image">
										<a onmouseout="javascript:stopUserInfoTimer(' . $aRow['ID'] . ')" onmouseover="javascript:startUserInfoTimer( ' . $aRow['ID'] . ', $(this).find(\'.dbcs-popup:first\') )" href="' . BX_DOL_URL_ROOT . $aRow['NickName'] . '">
											<div class="dbcs-popup"></div>						
											<img border="0" src="' . $oBaseFunctions -> getMemberAvatar($aRow['ID'],'small') . '">
										</a>
									</div>
								</div>
								</div>
							</td>
							<td class="gender_text_color_' . $aRow['Sex'] . '"><a href="' . BX_DOL_URL_ROOT . $aRow['NickName'] . '">' . $aRow['NickName'] . '</a></td>
						</tr>
					';
				}
				if($guestnum > 0){
					$sCode .= '
						<tr>
							<td style="padding:3px 4px" colspan="2">Guest User ('.$guestnum.')</td>
						</tr>';
				}
				$sCode .= '</table>';
			}else{
				if($guestnum > 0){
					$sCode .= 'Guest User ('.$guestnum.')';
				}else{
					$sCode .= 'No Users!';
				}				
			}
		}else{
			$sCode .= 'No Users!';
		}		
		$sCode .= '</div>';
		return $sCode;
	}
	
    /**
     * Function will generate the chat stats;
     */
    function serviceGetChatStats(){
        $sOutputCode = '';

        $status = self::getStatus();
        if (getParam('fc_user_list') == "1"){
            $users  = self::getUsers();
        }
        if ((getParam('fc_room_list') == "1") && (getParam('fc_server') != "2")){
            $rooms  = self::getRooms();
        }

        if (isset($status['ln'])){
            $sOutputCode .= '<b>' . $status['ln'] . '</b> login users.';
            if (isset($status['rn'])){
              $sOutputCode = '<p><b>' . $status['rn'] . '</b> rooms, ' . '<b>' . $status['cn'] . '</b> connections, ' . $sOutputCode . '</p>';
            }else{
            	$sOutputCode = '<p>'.$sOutputCode.'</p>';
            }
        }
        if(isset($rooms)){
            $sOutputCode .= "<b>Rooms:</b><p style='padding-left:10px;'>";
            if(!$rooms){
                $sOutputCode .= "None";
            }else{
	            $xa = '';
	            foreach($rooms as $room){
	                $sOutputCode .= $xa . '<a href="'.BX_DOL_URL_ROOT.'modules/?r=topcmmchat/home/&room=' . $room['id'] . '" target="_blank">' .$room['name'] .'</a>(' . $room['count'] . ')';
	                $xa = ",<br />";
	            }
        	}
        	$sOutputCode .= "</p>";
        }
        if(isset($users)){
            $sOutputCode .= "<b>Users:</b><p style='padding-left:10px;'>";
            if(!$users){
                $sOutputCode .= "None";
            }else{
	            $xb = '';
	            foreach($users as $user){
	                $sOutputCode .= $xb . $user['name'];
	                $xb = ', ';
	            }
            }
            $sOutputCode .= "</p>";
        }
		$js = 'onclick="window.open(\'modules/?r=topcmmchat/home/\');return false;"';
		$sOutputCode .= '<p style="text-align:center;"><b><a href="http://www.123flashchat.com" '.$js.'>Chat Now!</a></b></p>';
        $sOutputCode = '<div class="dbContent bx-def-bc-margin">' . $sOutputCode . '</div>';
        echo $sOutputCode;
    }

    /**
     * Function will get chat status;
     */
	function getStatus(){
        $data = topcmmRequestRemote::requestRemote(BX_DIRECTORY_PATH_CACHE."status.js",1);
	    $status_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$status_json){
	        $extendserver =  getParam('fc_extendserver');
	        switch ($extendserver){
	            case "0":
	        	    $status_js = getParam('fc_api_url') . "online.js";
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js, 1)){
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case "1":
	        	    $status_js = getParam('fc_api_url') . "online.js?group=" . getParam('fc_group');
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js, 1)){
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case "2":
	        	    $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . getParam('fc_room');
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js, 1)){
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	        	        $status['ln'] = $matches[1];
	        	        $status_json = json_encode($status);
	        	    }
	        	    break;
	        }
			file_put_contents(BX_DIRECTORY_PATH_CACHE . "status.js",(time() + 120) . $status_json);
	    }
		return json_decode($status_json,true);
	}

    /**
     * Function will get rooms;
     */
	function getRooms(){
        $data = topcmmRequestRemote::requestRemote(BX_DIRECTORY_PATH_CACHE."rooms.js",1);
		$rooms_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$rooms_json){
	    	$extendserver =  getParam('fc_extendserver');
	        switch ($extendserver){
	            case "0":
	        	    $room_js = getParam('fc_api_url') . "rooms.js";
	        	    break;
	            case "1":
	        	    $room_js = getParam('fc_api_url') . "rooms.js?group=" . getParam('fc_group');
	        	    break;
	        }
	    	if($rs = topcmmRequestRemote::requestRemote($room_js, 1)){
	        	$rooms_json = substr($rs,10,-1);
	        }
	        file_put_contents(BX_DIRECTORY_PATH_CACHE ."rooms.js",(time() + 120) . $rooms_json);
	    }
	    return json_decode($rooms_json, true);
	}
    /**
     * Function will get users;
     */
	function getUsers(){
		$data =  topcmmRequestRemote::requestRemote(BX_DIRECTORY_PATH_CACHE."users.js",1);
		$users_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$users_json){
	    	$extendserver =  getParam('fc_extendserver');
	        switch ($extendserver){
	            case "0":
	                $rooms = self::getRooms();
	                $users = array();
	                foreach ($rooms as $room){
	                    $user_js = getParam('fc_api_url') . "roomonlineusers.js?roomid=" . $room['id'];
	                    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
	                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
	                    }
	                }
	                $users_json = json_encode($users);
	        	    break;
	            case "1":
	        	    $user_js = getParam('fc_api_url') . "roomonlineusers.js?group=" . getParam('fc_group');
	        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
	        	        $users_json = substr($rs,20,-1);
	        	    }
	        	    break;
	        	case "2":
	        	    $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . getParam('fc_room');
	        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	    	            foreach (explode(',', $matches[1]) as $user){
	    	                $users[] = array('name' => $user);
	    	            }
	    	        }
	    	        $users_json = json_encode($users);
	    	        break;
	        }
	        $users_json = $this->filterUserList($users_json);
	        file_put_contents(BX_DIRECTORY_PATH_CACHE ."users.js",(time() + 120) . $users_json);
	    }
	    return json_decode($users_json, true);
	}
	
	function filterUserList($users_json){
		$user_array =  json_decode($users_json,true);
		$user_regroup_array = array();
		$user_tmp_array = array();
		foreach($user_array as $key => $val){
			if (!in_array($val['name'], $user_tmp_array)){
				$user_tmp_array[] = $val['name'];
				$user_regroup_array[$key] = $user_array[$key];
			}
		}
		return json_encode($user_regroup_array);
	}

	function getFlashChatUrl(){
		$url = '';
		$extendserver = getParam('fc_extendserver');
		$servertype = getParam('fc_servertype');
		$clienttype = getParam('fc_clienttype');
		$client_loc = getParam('fc_client_loc');
		$server_host_s = getParam('fc_server_host_s');
		$server_port_s = getParam('fc_server_port_s');
		$server_host_h = getParam('fc_server_host_h');
		$server_port_h = getParam('fc_server_port_h');
		
		switch($extendserver){
			case 0:
				if($servertype != 1 && $clienttype == 1){                
					$clientname = '123flashchat.swf';
				}else{
					$clientname = 'htmlchat/123flashchat.html';
				}
				$url .= $client_loc . $clientname . "?init_host=" . getParam('fc_server_host') . "&init_port=" . getParam('fc_server_port') ;
	            $url .= ($server_host_s ? "&init_host_s=".$server_host_s : "") . ($server_port_s ? "&init_port_s=".$server_port_s : "");
				$url .= ($server_host_h ? "&init_host_h=".$server_host_h : "") . ($server_port_h ? "&init_port_h=".$server_port_h : "");			
			break;
			case 1:
				if($clienttype == 1){
					$clientname = '123flashchat.swf';
				}else{
					$clientname = 'htmlchat/123flashchat.html';
				}
				$url = $client_loc . $clientname . "?init_host=" . getParam('fc_server_host') . "&init_port=" . getParam('fc_server_port');
	            $url .= ($server_host_s ? "&init_host_s=".$server_host_s : "") . ($server_port_s ? "&init_port_s=".$server_port_s : "");
				$url .= ($server_host_h ? "&init_host_h=".$server_host_h : "") . ($server_port_h ? "&init_port_h=".$server_port_h : "");
				$url .= "&init_group=" . getParam('fc_group');
			break;
			case 2:
				$url .= "http://free.123flashchat.com/js.php?room=" . urlencode(getParam('fc_room')) . "&skin="  . getParam('fc_client_skin') . "&lang="  . getParam('fc_client_lang');
			break;
		}
		if($_GET['room']){
			$url .= "&init_room=".$_GET['room'];
		}
		return $url;
	}

	function getValid(){
		$server_host = getParam('fc_server_host');
		$server_port_h = getParam('fc_server_port_h');
		$server_port_h = $server_port_h ? $server_port_h : 35555;
		$c_server_loc = 1;
		if($server_host){
			if($server_host == $_SERVER['SERVER_NAME']){
				$c_own_loc = $this->validate_client('http://'.$server_host.':'.$server_port_h.'/');
				if(!$c_own_loc){
					$c_server_loc = 0;
				}
			}
		}else{
			$c_own_loc = $this->validate_client('http://'.$_SERVER['SERVER_NAME'].':'.$server_port_h.'/');
			if(!$c_own_loc){
				$c_server_loc = 0;
			}
		}
		return $c_server_loc;
	}
	
	function saveLocalSettings(){
		$data['fc_extendserver'] = "0";
		$data['fc_servertype'] = $_POST['servertype'];
		$client_location = $_POST['client_loc'];
		if($client_location){
			$data['fc_client_loc'] = $client_location . (substr($client_location,-1,1) != '/' ? '/' : '');
	        $serverinfo = $this->getServerHostPortLocal($data['fc_client_loc']);
	        $data['fc_server_host'] = !empty($_POST['server_host']) ? $_POST['server_host'] : (empty($serverinfo['fc_server_host']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host']) ;
	        $data['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? $data['fc_server_host'] : $serverinfo['fc_server_host_s'];
	        $data['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? $data['fc_server_host'] : $serverinfo['fc_server_host_h'];
			
	        if(!is_numeric($_POST['server_port']) || strpos($_POST['server_port'] ,".")!==false){
				$data['fc_server_port'] = empty($serverinfo['fc_server_port']) ? ( $data['fc_servertype'] == 1 ? '51212' : '51127') : $serverinfo['fc_server_port'] ;
			}else{
				$data['fc_server_port'] = $_POST['server_port'];
			}
			if(!is_numeric($_POST['server_port_h']) || strpos($_POST['server_port_h'] ,".")!==false){
				$data['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? ( $data['fc_servertype'] == 1 ? '31212' : '35555') : $serverinfo['fc_server_port_h'] ;
			}else{
				$data['fc_server_port_h'] = $_POST['server_port_h'];
			}
	        $data['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? ( $data['fc_servertype'] == 1 ? '51213' : '51128') : $serverinfo['fc_server_port_s'] ;
			$data['fc_api_url'] = 'http://' . $data['fc_server_host'] . ':' . $data['fc_server_port_h'] . '/';        
		}else{
			$data['fc_server_host'] = $_SERVER['HTTP_HOST'];
	        $data['fc_server_host_h'] = $data['fc_server_host_s'] = $data['fc_server_host'];
			if($data['fc_servertype']){
				$data['fc_server_port_h'] = '31212';
	            $data['fc_server_port_s'] = '51213';
				$data['fc_server_port'] = '51212';
			}else{
				$data['fc_server_port_h'] = '35555';
	            $data['fc_server_port_s'] = '51128';
				$data['fc_server_port'] = '51127';
			}
			$data['fc_api_url'] = 'http://' . $data['fc_server_host'] . ':' . $data['fc_server_port_h'] . '/';
			$data['fc_client_loc'] = $data['fc_api_url'];
		}
	    if($data['fc_servertype'] == 1){
	        $data['fc_clienttype'] = 0;
	    }else{
	        $data['fc_clienttype'] = $_POST['clienttype'];            
	    }
		$s_own_loc = 1;
		$c_own_loc = 1;
		$da = 1;
		if($_POST['server_local']){
			$c_own_loc = $this->validate_client($data['fc_client_loc']);
			$da = $this->validate_data_api($data['fc_api_url'] . 'online.js');
			if($c_own_loc || $da){
				return "Client Location is configured incorrectly!";
			}
		}else{
			$c_own_loc = $this->validate_client($data['fc_client_loc']);
			if($c_own_loc){
				return "Client Location is configured incorrectly!";
			}
		}
		$check = $this->validate_client('http://'.parse_url($data['fc_client_loc'], PHP_URL_HOST).':'.$data['fc_server_port_h'].'/');
		if($check){
			return "Client Location is not available!";
		}
		return $data;
	}

	function saveHostSettings(){
		$data['fc_extendserver'] = "1";
		$data['fc_client_loc'] = !empty($_POST['client_loc']) ? ($_POST['client_loc'] . (substr($_POST['client_loc'],-1,1) != '/' ? '/' : '')) : '';
		if($data['fc_client_loc'] == ''){
			return "Client Location could not be empty!";
		}
	    $serverinfo = $this->getServerHostPortHost($data['fc_client_loc']);
	    if($serverinfo){
	        $data['fc_server_host'] = empty($serverinfo['fc_server_host']) ? parse_url($data['fc_client_loc'], PHP_URL_HOST) : $serverinfo['fc_server_host'];
			$data['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? '' : $serverinfo['fc_server_host_s'];
			$data['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? '' : $serverinfo['fc_server_host_h'];
			$data['fc_server_port'] = empty($serverinfo['fc_server_port']) ? '' : $serverinfo['fc_server_port'];
			$data['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? '' : $serverinfo['fc_server_port_h'];
			$data['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? '' : $serverinfo['fc_server_port_s'];        
	    	$data['fc_api_url'] = 'http://' . $data['fc_server_host'] . '/';
	    	$data['fc_group'] = substr(parse_url($data['fc_client_loc'], PHP_URL_PATH),1,-1);
	        $c_own_loc = $this->validate_client($data['fc_client_loc']);
			$da = $this->validate_data_api($data['fc_api_url'] . 'online.js?group=' . $data['fc_group']);
			if($c_own_loc || $da){
				return "Client Location is configured incorrectly!";
			}        
	    }else{
	        return "Client Location is configured incorrectly!";
	    }
	    $data['fc_clienttype'] = $_POST['clienttype'];
		return $data;
	}
	
	function saveFreeSettings(){
		$data['fc_extendserver'] = "2";
		$room = trim($_POST['room']);
		if($room != ""){
			preg_match("/\w+$/", $room,$matches);
			if(strlen($room) != strlen($matches[0])){
				return "Chat Room can only use numbers,letters and underline!";
			}
			$data['fc_room'] = $room;
		}else{
			$data['fc_room'] = 'Lobby';
		}
		return $data;
	}
	
	function getServerHostPortLocal($client_location){
		$content = topcmmRequestRemote::requestRemote($client_location.'htmlchat/config/config.js',1);
		if ($content){
			//server host
		 	preg_match('/init_host="([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host = "([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host'] = '';
		        }
	        }
	        //server port
	        preg_match('/init_port=([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port'] = $matches[1];			        	
	        }else{
	        	preg_match('/init_port = ([0-9]*);/', $content, $matches);
	            if(isset($matches[1])){
	            	$data['fc_server_port'] = $matches[1];			        	
	            }else{
	            	$data['fc_server_port'] = '';
	            }
	        }
	        //server host s
			preg_match('/init_host_s="([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host_s = "([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host_s'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host_s'] = '';
		        }
	        }
	        //server port s
	        preg_match('/init_port_s=([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_s'] = $matches[1];			        	
	        }else{
	        	preg_match('/init_port_s = ([0-9]*);/', $content, $matches);
	            if(isset($matches[1])){
	            	$data['fc_server_port_s'] = $matches[1];			        	
	            }else{
	            	$data['fc_server_port_s'] = '';
	            }
	        }
	        //server host h
			preg_match('/init_host_h="([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host_h = "([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host_h'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host_h'] = '';
		        }
	        }
	        //server port h
	        preg_match('/init_port_h=([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_h'] = $matches[1];			        	
	        }else{
	        	preg_match('/init_port_h = ([0-9]*);/', $content, $matches);
	            if(isset($matches[1])){
	            	$data['fc_server_port_h'] = $matches[1];			        	
	            }else{
	            	$data['fc_server_port_h'] = '';
	            }
	        }
	        return $data;
	    }else{
	    	return false;
	    }
	}

	function getServerHostPortHost($client_location){
		$content = topcmmRequestRemote::requestRemote($client_location,1);
		if ($content){
			//server port
			preg_match('/init_port=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port'] = $matches[1];			        	
	        }
	        //server port s
			preg_match('/init_port_s=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_s'] = $matches[1];			        	
	        }
	        //server port h
			preg_match('/init_port_h=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_h'] = $matches[1];			        	
	        }
	        //server host
			preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }
	        //server host s
			preg_match('/init_host_s=([a-zA-Z0-9.]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }
	        //server host h
			preg_match('/init_host_h=([a-zA-Z0-9.]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }
	        return $data;
	    }else{
	        return false;
	    }
	}
	
}
